﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public FB_APP_ID As String = "PASTE YOUR FB APP ID HERE"
	Public FB_APP_SECRET As String = "PASTE YOUR APP SECRET HERE"
	Public FB_AUTH_PERMISSIONS As String = "publish_actions"
	Public FB_REDIRECT_URL As String = "http://www.zarhounisystems.com/" 'replace this with what you configured in FB console
	Private CallingObject As Object
	Private FB_CRED_STORE As KeyValueStore
	Private FB_CRED_FILE As String = "fb_creds.fc"
	Private FB_CRED_KEY As String = "fb_creds"
	Private KS_PASSWD As String = "changeme"
	
	Type FBAccessCredentials(AccessToken As String, AuthSecret As String, Expiry As Long, ExpiryInTicks As Long)
	Private FAC As FBAccessCredentials

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pCallingObject As Object)
	CallingObject = pCallingObject
	FB_CRED_STORE.Initialize(File.DirInternal,FB_CRED_FILE)
	If Not(IsAuthFlowCompleted) AND Not(CallingObject=Null) Then
		StartFBOAuthFlow
	End If
End Sub
Public Sub IsAuthFlowCompleted As Boolean
	Dim Ret As Boolean = False
	If IsAccessTokenSaved AND Not(TokenExpired) Then
		Ret =  True
	End If
	Return Ret
End Sub
Private Sub IsAccessTokenSaved As Boolean
	Dim Ret As Boolean = False
	If FB_CRED_STORE.ListKeys.Size > 0 Then
		Ret = True
	End If
	Return Ret
End Sub
Private Sub TokenExpired As Boolean
	Dim Ret As Boolean = True
	FAC = FB_CRED_STORE.GetEncryptedObject(FB_CRED_KEY,KS_PASSWD)
	If FAC.Expiry > DateTime.Now Then
		Ret =  False
	Else
		Ret = True
	End If
	Return Ret
End Sub

Private Sub StartFBOAuthFlow
	HttpUtils.CallbackActivity = "Main"
	HttpUtils.CallbackJobDoneSub = "OnAPICallComplete" 'this method will be called when we get a response from FB for access token
	CallSubDelayed(CallingObject,"StartFBOAuthFlow")
End Sub

Public Sub GetFBAccessToken(AuthToken As String)
	HttpUtils.Download("AccessToken", "https://graph.facebook.com/oauth/access_token?client_id=" & FB_APP_ID &"&redirect_uri=" & FB_REDIRECT_URL & "&client_secret=" & FB_APP_SECRET & "&code="&AuthToken)
End Sub

Public Sub SaveFBAccessToken(Response As String)
	Dim Parts() As String = Regex.Split("&",Response)
	FAC.Initialize
	For Each Part In Parts
		Dim Param() As String = Regex.Split("=",Part)
		Select Param(0)
			Case "access_token"
				FAC.AccessToken = Param(1)
			Case "expires"
				FAC.Expiry = Param(1)
				FAC.Expiry = FAC.Expiry + DateTime.Now
		End Select
	Next
	SaveTokenToStore
End Sub

Private Sub SaveTokenToStore
	FB_CRED_STORE.PutEncyptedObject(FB_CRED_KEY,FAC, KS_PASSWD)
End Sub

Public Sub PostStatus(Message As String)
	If IsAuthFlowCompleted Then
		HttpUtils.CallbackActivity = "Main" 'this can be the name of a service module as well
		HttpUtils.CallbackJobDoneSub = "OnAPICallComplete"
		Log("Calling Graph API")
		HttpUtils.PostString("PostFBStatus","https://graph.facebook.com/me/feed?access_token=" & FAC.AccessToken,"message="&Message)
	End If
End Sub
